## dpkg 1.20.7.1

=== tests/Makefile ===
#
# Dpkg functional testsuite (kind of)
#
# Copyright © 2008-2015 Guillem Jover <guillem@debian.org>
#


-include .pkg-tests.conf

## Feature checks setup ##

include Feature.mk

## Test cases ##

TESTS_MANUAL :=
TESTS_MANUAL += t-deb-lfs
TESTS_MANUAL += t-conffile-prompt

TESTS_FAIL :=
TESTS_FAIL += t-dir-leftover-deadlock
TESTS_FAIL += t-dir-shared-replaces-lost
TESTS_FAIL += t-disappear-depended
TESTS_FAIL += t-conffile-divert-conffile
TESTS_FAIL += t-breaks-multiarch

TESTS_PASS :=
TESTS_PASS += t-db
TESTS_PASS += t-normal
TESTS_PASS += t-field-priority
TESTS_PASS += t-option-dry-run
TESTS_PASS += t-option-recursive
TESTS_PASS += t-control-bogus
TESTS_PASS += t-control-no-arch
TESTS_PASS += t-unpack-symlink
TESTS_PASS += t-unpack-hardlink
TESTS_PASS += t-unpack-divert-hardlink
TESTS_PASS += t-unpack-divert-nowarn
TESTS_PASS += t-unpack-fifo
ifdef DPKG_AS_ROOT
# No permissions for devices
TESTS_PASS += t-unpack-device
endif
TESTS_PASS += t-maintscript-leak
TESTS_PASS += t-filtering
TESTS_PASS += t-depends
TESTS_PASS += t-dir-leftover-parents
TESTS_PASS += t-dir-leftover-conffile
TESTS_PASS += t-disappear
TESTS_PASS += t-disappear-empty
TESTS_PASS += t-provides
TESTS_PASS += t-provides-self
TESTS_PASS += t-provides-arch-implicit
TESTS_PASS += t-provides-arch-qualified
TESTS_PASS += t-breaks
TESTS_PASS += t-conflicts
TESTS_PASS += t-conflict-provide-replace-real
TESTS_PASS += t-conflict-provide-replace-virtual
TESTS_PASS += t-conflict-provide-replace-virtual-multiarch
TESTS_PASS += t-conflict-provide-replace-interface
TESTS_PASS += t-predepends-no-triggers
TESTS_PASS += t-triggers
TESTS_PASS += t-triggers-configure
TESTS_PASS += t-triggers-path
TESTS_PASS += t-triggers-depends
TESTS_PASS += t-triggers-depcycle
TESTS_PASS += t-triggers-depfarcycle
TESTS_PASS += t-triggers-selfcycle
TESTS_PASS += t-triggers-cycle
TESTS_PASS += t-triggers-halt
TESTS_PASS += t-file-conflicts
TESTS_PASS += t-file-replaces
TESTS_PASS += t-file-replaces-disappear
TESTS_PASS += t-file-replaces-versioned
TESTS_PASS += t-conffile-normal
TESTS_PASS += t-conffile-obsolete
TESTS_PASS += t-conffile-orphan
TESTS_PASS += t-conffile-forcemiss
TESTS_PASS += t-conffile-forcenew
TESTS_PASS += t-conffile-forceask
TESTS_PASS += t-conffile-root-option
TESTS_PASS += t-conffile-divert-normal
TESTS_PASS += t-conffile-conflict
TESTS_PASS += t-conffile-replaces
TESTS_PASS += t-conffile-replaces-upgrade
TESTS_PASS += t-conffile-replaces-downgrade
TESTS_PASS += t-conffile-replaces-existing
TESTS_PASS += t-conffile-replaces-existing-and-upgrade
TESTS_PASS += t-conffile-replaces-disappear
TESTS_PASS += t-conffile-replaces-diverted
TESTS_PASS += t-conffile-versioned-replaces-downgrade
TESTS_PASS += t-conffile-rename
TESTS_PASS += t-conffile-declarative-removal
TESTS_PASS += t-queue-process-deconf-dupe
TESTS_PASS += t-symlink-dir
TESTS_PASS += t-switch-symlink-abs-to-dir
TESTS_PASS += t-switch-symlink-rel-to-dir
TESTS_PASS += t-switch-dir-to-symlink-abs
TESTS_PASS += t-switch-dir-to-symlink-rel
TESTS_PASS += t-failinst-failrm
TESTS_PASS += t-dir-extension-check
TESTS_PASS += t-multiarch

ifneq (,$(filter test-all,$(DPKG_TESTSUITE_OPTIONS)))
TESTS := $(TESTS_PASS) $(TESTS_FAIL) $(TESTS_MANUAL)
else
TESTS := $(TESTS_PASS)
endif


# By default do nothing
all help::
	@echo "Run 'make test' to run all the tests"
	@echo "Run 'make <test-id>-test' to run a specifict test"
	@echo "Run 'make clean' to remove all intermediary files"
	@echo ""
	@echo "The available tests are: $(TESTS)"

build_targets = $(addsuffix -build,$(TESTS))

build:: $(build_targets)
$(build_targets)::
	$(MAKE) -C $(subst -build,,$@) build

.PHONY: build $(build_targets)


test_targets = $(addsuffix -test,$(TESTS))

test:: $(test_targets)
$(test_targets)::
	$(MAKE) -C $(subst -test,,$@) test

.PHONY: test $(test_targets)


test_clean_targets = $(addsuffix -test-clean,$(TESTS))

test-clean:: $(test_clean_targets)
$(test_clean_targets)::
	$(MAKE) -C $(subst -test-clean,,$@) test-clean

.PHONY: test-clean $(test_clean_targets)


clean_targets = $(addsuffix -clean,$(TESTS))

clean:: $(clean_targets)
$(clean_targets)::
	$(MAKE) -C $(subst -clean,,$@) clean

.PHONY: clean $(clean_targets)

=== debian/changelog ===
dpkg (1.20.7.1) unstable; urgency=medium

  * Regenerate source package to include disappeared top-level Makefile.in.

 -- Guillem Jover <guillem@debian.org>  Sat, 09 Jan 2021 07:11:57 +0100

dpkg (1.20.7) unstable; urgency=medium

  [ Guillem Jover ]
  * libdpkg: Do not consider the database locked with a missing lock file.
    Reported by David Kalnischkies <donkult@debian.org>.
  * Documentation:
    - man: Clarify and expand information on dpkg-realpath(1) man page.
      Closes: #979564
  * Packaging:
    - Update copyright notices in debian/copyright.
    - Bump Standards-Version to 4.5.1 (no changes required).
  * Test suite:
    - On as-root mode do not use sudo if already running as root.
    - Print WARN instead of FAIL for maintscript fd leaks.

  [ Update man pages translations ]
  * German (Helge Kreutzmann).

  [ Update programs translations ]
  * German (Sven Joachim).

 -- Guillem Jover <guillem@debian.org>  Sat, 09 Jan 2021 00:59:45 +0100

dpkg (1.20.6) unstable; urgency=medium

  [ Guillem Jover ]
  * libdpkg: Fix undefined behavior in varbuf functions.
    Reported by KOLANICH <kolan_n@mail.ru>.
  * libdpkg: Fix memory leaks in tar_extractor().
  * libdpkg: Fix memory leak in trigger deferred processing.
    Reported by KOLANICH <kolan_n@mail.ru>.
  * libdpkg: Fix memory leak in filesystem treewalk node free function.
  * libdpkg: Fix memory leak in filesystem treewalk iterator.
  * libdpkg: Fix single-instance memory leak with fsys dir.
  * libdpkg: Fix short-lived memory leaks.
  * libdpkg: Reset error context errmsg after free().
  * dpkg: Fix memory leak for cidir.
    Reported by KOLANICH <kolan_n@mail.ru>.
  * dpkg: Fix short-lived memory leak in --force-help output.
    Based on a patch by KOLANICH <kolan_n@mail.ru>.
  * dpkg-deb: Fix single-instance memory leak on missing conffiles control
    file.
  * dpkg-divert: Fix short-lived memory leaks.
  * dpkg-realpath: Add new -z, --zero option.
    Requested by Johannes Schauer <josch@debian.org>.
  * dpkg-deb: Make decompression error message more descriptive.
    Closes: #968442
  * dpkg-architecture: Add a --print-format option.
    Prompted by #968963.
  * dpkg-buildpackage: Warn on known R³ values in uppercase.
    Reported by Niels Thykier <niels@thykier.net>.
  * dpkg-buildpackage: Error out on R³ "yes" value.
    Requested by Niels Thykier <niels@thykier.net>.
  * dpkg-buildpackage: Clarify R³ keyword diagnostic messages.
  * dpkg-deb, dpkg-split: Fix time handling to support 64-bit time.
  * libdpkg: Check that the ar archive time is within bounds.
  * libdpkg: Ignore not-installed packages for source related virtual fields.
    Closes: #972580
  * libdpkg: Make source version parsing more robust on missing data.
    See #972580.
  * libdpkg: Do not forget not-installed packages that are set on hold.
    Reported by David Kalnischkies <donkult@debian.org>.
  * update-alternatives: Fix memory leaks for alternative database context on
    load errors.
  * update-alternatives: Fix short-lived memory leaks for alternative structs.
  * update-alternatives: Fix memory leaks with new_choice.
  * update-alternatives: Fix short-lived memory leaks for log_file and admdir.
  * dpkg-buildflags: Add support for DFLAGS. Closes: #975896
  * dpkg-parsechanaglog: Document --file in --help output.
  * libdpkg: Fix allocation size wrap around when growing a varbuf.
  * dpkg-query: Do not print database loading progress. Closes: #977240
  * Rename taint tag to merged-usr-via-aliased-dirs.
  * dpkg-buildflags: Enable reproducible=fixfilepath by default.
    Thanks to Vagrant Cascadian <vagrant@reproducible-builds.org>.
    See https://lists.debian.org/debian-devel/2020/10/msg00222.html.
    Closes: #974087
  * start-stop-daemon: Move umask setup before any file has been created.
  * start-stop-daemon: Add a new --output option to redirect stderr and stdout.
  * dpkg-maintscript-helper: Do not pass DPKG_ROOT prefixed pathmames to
    dpkg-realpath.
  * dpkg: When removing old files check the pathname with diversion and
    instdir.
  * dpkg-realpath: Make 'link includes root prefix' error more verbose.
  * libdpkg: Make sure we do not walk on rootless trees.
  * dpkg: Fix incorrect logic around printing dependency warnings.
    Thanks to Jessica Clarke <jrtc27@debian.org>.
    Reported by Helmut Grohne <helmut@subdivi.de>.
  * Support remove-on-upgrade conffile flag via DEBIAN/conffiles.
    Based on a patch by Niels Thykier <niels@thykier.net>. Closes: #822462
  * dpkg-fsys-usrunmess: New program.
  * Perl modules:
    - Dpkg::Index: Add new item_opts option.
    - Dpkg::Exit: Fix exit handler on program termination. Closes: #966083
    - Dpkg::Changelog::Entry::Debian: Fix format string.
      Prompted by #967911.
    - Dpkg::Changelog::Parse: Add new verbose option.
      Prompted by #967911.
    - Dpkg::Changelog::Parse: Document 'label' option.
    - Dpkg::Source::Package::V1: Print a message when verifying tarball
      signatures.
    - Dpkg::Path: Fix pathname traversal check for symlinks. Closes: #971203
    - Dpkg::Source::Package: Honor no_check for directory traversal checks.
      See #971203.
    - Dpkg::Source::Package: Call syserr() instead of syserror().
      Reported by Drew Parsons <dparsons@debian.org>.
      See #849752. Closes: #976249
    - Dpkg::Path: Check first whether the files are the same by comparing
      string-wise. Closes: #849752
    - Dpkg::OpenPGP: Refactor gpg armor code into its own function.
  * Documentation:
    - man: Fix typo in --print-unset option reference.
      Reported by Ferenc Wágner <wferi@debian.org>. Closes: #966110
    - man: Clarify that dpkg-architecture uses some of its own variables.
      Closes: #966111
    - man: Fix casing and namespacing in VARIABLES definitions.
    - man: Fix typo in dpkg-source(1).
      Thanks to Paul Wise <pabs@debian.org>.
    - man: Add a reference to deb-symbols(5) in deb-src-symbols(5) DESCRIPTION.
      Prompted by #970083.


## dpkg 1.20.9ubuntu1

=== debian/changelog ===
dpkg (1.20.9ubuntu1) hirsute; urgency=medium

  * Merge with Debian; remaining changes:
    - Change native source version/format mismatch errors into warnings
      until the dust settles on Debian bug 737634 about override options.
    - Add DPKG_UNTRANSLATED_MESSAGES environment check so that higher-level
      tools can get untranslated dpkg terminal log messages while at the
      same time having translated debconf prompts.
    - Special-case arm{el,hf} ELF objects in Shlibs/Objdump.pm for multilib.
    - Map unqualified package names of multiarch-same packages to the native
      arch instead of throwing an error, so that we don't break on upgrade
      when there are unqualified names stored in the dpkg trigger database.
    - Apply a workaround from mvo to consider ^rc packages as multiarch,
      during the dpkg consistency checks. (see LP: 1015567 and 1057367).
    - dpkg-gencontrol: Fix Package-Type override handling for ddeb support.
    - Add Zstd compression and decompression support for binary packages.
    - scripts/Dpkg/Vendor/Ubuntu.pm: set 'nocheck' in build options by default
      on Ubuntu/riscv64.  Overridable in debian/rules with
      'DEB_BUILD_OPTIONS := $(filter-out nocheck,$(DEB_BUILD_OPTIONS))'.
    - scripts/Dpkg/Vendor/Ubuntu.pm, scripts/dpkg-buildpackage.pl:
      Set 'nocheck' for riscv64 using a new 'update-buildopts' hook and make
      it effective with old style debhelper, too.
    - Dpkg::Vendor::Debian: Add new lto feature in new optimize area, taken
      from
      https://git.hadrons.org/cgit/debian/dpkg/dpkg.git/log/?h=next/1.21.x
    - dpkg-dev: Depend on lto-disabled-list.
    - dpkg-buildflags: Read package source names from lto-disabled-list,
      to build without lto optimizations. When adding a source package to the
      list, please also file a launchpad issue and tag it with 'lto'.
    - Turn on LTO optimizations on amd64, arm64, ppc64el, s390x.
      See https://wiki.ubuntu.com/ToolChain/LTO for more information.
    - scripts/Dpkg/Vendor/Ubuntu.pm: set 'noudeb' build profile by
      default. Override this by exporting DEB_BUILD_PROFILE='!noudeb' which
      will be stripped, and thus building with udebs. LP: #1884836

 -- Matthias Klose <doko@ubuntu.com>  Wed, 14 Apr 2021 12:32:22 +0200

dpkg (1.20.9) unstable; urgency=medium

  [ Guillem Jover ]
  * Test suite:
    - Pass --ignore-builtin-builddeps to dpkg-buildpackage.

 -- Guillem Jover <guillem@debian.org>  Wed, 14 Apr 2021 00:43:39 +0200

dpkg (1.20.8) unstable; urgency=medium

  [ Guillem Jover ]
  * start-stop-daemon: Open the --output file in append mode.
  * dpkg: Fix --auto-deconfigure for essential and protected during
    installation. Reported by Julian Andres Klode <jak@debian.org>.
    See #983014.
  * dpkg-realpath: Fix resolution for absolute symlinks on «/».
    Closes: #983855
  * dpkg-realpath: Fix symlink loop tracker.
  * Perl modules:
    - Test::Dpkg: Fix test data path fetching on CPAN.
    - Dpkg::Exit: Preserve exit code in END block.
  * Build system:
    - Group Test::Dpkg changelog entries into “Perl modules” section.
  * Packaging:
    - Run autopkgtest test suites in verbose mode.
  * Test suite:
    - Set PERL in the perl test suite.
    - Use gunzip instead of zcat and assume it might not be present.
    - Mock dpkg and gcc for architecture detection code.
    - Initialize DEB_BUILD_ARCH and DEB_HOST_ARCH to avoid computing them.
    - Update suppressions for cppcheck 2.4.

  [ Update man pages translations ]
  * Dutch (Frans Spiesschaert). Closes: #981884
  * German (Helge Kreutzmann).
  * Portuguese (Américo Monteiro). Closes: #980018

  [ Update programs translations ]
  * Dutch (Frans Spiesschaert). Closes: #981882

  [ Update scripts translations ]
  * German (Helge Kreutzmann). Closes: #983865

 -- Guillem Jover <guillem@debian.org>  Tue, 13 Apr 2021 22:17:05 +0200

dpkg (1.20.7.1ubuntu4) hirsute; urgency=medium

  * Turn on LTO optimizations on amd64, arm64, ppc64el, s390x.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 19 Mar 2021 14:44:20 +0100

dpkg (1.20.7.1ubuntu3) hirsute; urgency=medium

  * scripts/Dpkg/Vendor/Ubuntu.pm: set 'noudeb' build profile by
    default. Override this by exporting DEB_BUILD_PROFILE='!noudeb' which
    will be stripped, and thus building with udebs. LP: #1884836

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 18 Feb 2021 19:58:48 +0000

dpkg (1.20.7.1ubuntu2) hirsute; urgency=medium

  * Dpkg::Vendor::Debian: Add new lto feature in new optimize area, taken
    from
    https://git.hadrons.org/cgit/debian/dpkg/dpkg.git/log/?h=next/1.21.x
  * dpkg-dev: Depend on lto-disabled-list.
  * dpkg-buildflags: Read package source names from lto-disabled-list,
    to build without lto optimizations. When adding a source package to the
    list, please also file a launchpad issue and tag it with 'lto'.
  * LTO optimizations are still turned off. To turn them on for a package
    build, append 'optimize=+lto' to DEB_BUILD_MAINT_OPTIONS before calling
    dpkg-buildflags.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 28 Jan 2021 10:00:33 +0100

dpkg (1.20.7.1ubuntu1) hirsute; urgency=medium

  * Merge with Debian; remaining changes:
    - Change native source version/format mismatch errors into warnings
      until the dust settles on Debian bug 737634 about override options.
    - Add DPKG_UNTRANSLATED_MESSAGES environment check so that higher-level
      tools can get untranslated dpkg terminal log messages while at the
      same time having translated debconf prompts.
    - Special-case arm{el,hf} ELF objects in Shlibs/Objdump.pm for multilib.
    - Map unqualified package names of multiarch-same packages to the native
      arch instead of throwing an error, so that we don't break on upgrade
      when there are unqualified names stored in the dpkg trigger database.
    - Apply a workaround from mvo to consider ^rc packages as multiarch,
      during the dpkg consistency checks. (see LP: 1015567 and 1057367).


=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for the dpkg suite.
# Copyright © 2004 Scott James Remnant <scott@netsplit.com>
# Copyright © 2006-2012 Guillem Jover <guillem@debian.org>

WFLAGS := \
	-Wall -Wextra \
	-Wno-missing-field-initializers \
	-Wno-nonnull-compare \
	-Wno-unused-parameter \
	$(nil)

# Use the in-tree dpkg-buildflags
dpkg_buildflags = \
	DEB_BUILD_MAINT_OPTIONS="hardening=+all" \
	DEB_CFLAGS_MAINT_APPEND="$(WFLAGS)" \
	DEB_CXXFLAGS_MAINT_APPEND="$(WFLAGS)" \
	$(CURDIR)/run-script scripts/dpkg-buildflags.pl

DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_HOST_ARCH_OS    ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_MULTIARCH  ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Support cross-compiling.
ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
	confflags += --build=$(DEB_HOST_GNU_TYPE)
else
	confflags += --build=$(DEB_BUILD_GNU_TYPE) --host=$(DEB_HOST_GNU_TYPE)
endif

# Do not enable everything on all platforms.
ifeq ($(DEB_HOST_ARCH_OS),linux)
	confflags += --with-libselinux
endif
ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
	confflags += --disable-silent-rules
	testflags += TESTSUITEFLAGS=--verbose
endif

# Enable parallel test suite
NUMJOBS = 1
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  MAKEFLAGS += -j$(NUMJOBS)
endif

D := $(CURDIR)/debian/tmp

# Configure the build tree
build-tree/config.status:
	dh_testdir
	dh_autoreconf

	install -d build-tree
	cd build-tree && ../configure $(confflags) \
		$(shell $(dpkg_buildflags) --export=configure) \
		--prefix=/usr \
		--mandir=\$${datadir}/man \
		--infodir=\$${datadir}/info \
		--sysconfdir=/etc \
		--sbindir=/sbin \
		--localstatedir=/var \
		--libexecdir=\$${exec_prefix}/lib \
		--with-devlibdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) \
		--without-libmd \
		--with-libz \
		--with-libzstd \
		--with-liblzma \
		--with-libbz2

# Build the package in build-tree
build-indep build-arch build: build-tree/config.status
	dh_testdir

	cd build-tree && $(MAKE)

# Run the test suites
check: build
	dh_testdir

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd build-tree && $(MAKE) $(testflags) TEST_PARALLEL=$(NUMJOBS) check
endif

# Install the package underneath debian/tmp
install: check
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	cd build-tree && $(MAKE) DESTDIR=$(D) install

	# Special-case the lintian profile, as dh cannot rename on install.
	mkdir -p $(D)/usr/share/lintian/profiles/dpkg
	cp debian/dpkg.lintian-profile \
	   $(D)/usr/share/lintian/profiles/dpkg/main.profile

define dpkg-installmanl10n
for f in `sed -e 's:\*:*/*:' -e 's:^:$(D)/:' debian/$(1).manpages`; do \
  if [ -e $$f ]; then \
    install -D $$f `echo $$f | sed -e 's:^$(D):debian/$(1):'`; \
  fi; \
done
endef

# Put together the dpkg and dselect packages
binary-arch: install
	dh_testdir -a
	dh_testroot -a
	dh_install -a
	dh_installcron -a
	dh_installlogrotate -a
	dh_installlogrotate -a --name=alternatives
	dh_installchangelogs -a ChangeLog*
	dh_installdocs -a
	$(call dpkg-installmanl10n,dpkg)
	$(call dpkg-installmanl10n,dselect)
	dh_installman -a
	dh_link -a
	dh_bugfiles -a -A
	dh_lintian -a
	dh_strip -a
	dh_compress -a
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

# Put together the dpkg-dev package
binary-indep: install
	dh_testdir -i
	dh_testroot -i
	dh_install -i
	dh_installcron -i
	dh_installchangelogs -i ChangeLog*
	dh_installdocs -i -Ndpkg-dev
	dh_installdocs -pdpkg-dev --doc-main-package=dpkg
	$(call dpkg-installmanl10n,dpkg-dev)
	dh_installman -i
	dh_link -i
	dh_bugfiles -i -A
	dh_lintian -i
	dh_perl -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

binary: binary-arch binary-indep


# Clean up the mess we made
clean:
	dh_testdir

	[ ! -f Makefile ] || $(MAKE) distclean
	rm -rf build-tree
	dh_autoreconf_clean
	dh_clean


.PHONY: build check install binary-arch binary-indep binary clean

## dpkg 1.20.9ubuntu2

=== debian/changelog ===
dpkg (1.20.9ubuntu2) impish; urgency=medium

  * build: Switch default dpkg-deb compression from xz to zstd. (LP: #1923845)
    Keep compressing dpkg.deb with xz to help bootstrapping on non-Ubuntu
    systems.

 -- Balint Reczey <balint@balintreczey.hu>  Mon, 14 Jun 2021 16:04:10 +0200

=== debian/control ===
Source: dpkg
Section: admin
Priority: required
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
Uploaders: Guillem Jover <guillem@debian.org>
Homepage: https://wiki.debian.org/Teams/Dpkg
Vcs-Browser: https://git.dpkg.org/cgit/dpkg/dpkg.git
Vcs-Git: https://git.dpkg.org/git/dpkg/dpkg.git
Standards-Version: 4.5.1
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 pkg-config,
# Needed for ITS support.
 gettext (>= 0.19.7),
# Needed for --porefs defaults, conditional addenda and mode=eof.
 po4a (>= 0.59),
 zlib1g-dev,
 zstd,
 libbz2-dev,
 libzstd-dev,
 liblzma-dev,
 libselinux1-dev [linux-any],
 libncurses-dev (>= 6.1+20180210) | libncursesw5-dev,
# Needed for the functional test.
 bzip2 <!nocheck>,
 xz-utils <!nocheck>,

Package: dpkg
Architecture: any
Multi-Arch: foreign
Essential: yes
Pre-Depends:
 ${shlibs:Depends},
Depends:
 ${misc:Depends},
# Needed for --clamp-mtime in dpkg-deb -b.
 tar (>= 1.28-1),
Suggests:
 apt,
 debsig-verify,
Breaks:
# Due to --status-fd not duplicating output.
 libapt-pkg5.0 (<< 1.7~b),
# Due to s-s-d requiring secure usage of --pidfile.
 lsb-base (<< 10.2019031300),
Description: Debian package management system
 This package provides the low-level infrastructure for handling the
 installation and removal of Debian software packages.
 .
 For Debian package development tools, install dpkg-dev.

Package: libdpkg-dev
Section: libdevel
Priority: optional
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 zlib1g-dev,
 libzstd-dev,
 liblzma-dev,
 libbz2-dev,
Description: Debian package management static library
 This package provides the header files and static library necessary to
 develop software using libdpkg, the same library used internally by dpkg.
 .
 Note though, that the API is to be considered volatile, and might change
 at any time, use at your own risk.

Package: dpkg-dev
Section: utils
Priority: optional
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${perl:Depends},
 libdpkg-perl (= ${source:Version}),
# Needed for --clamp-mtime.
 tar (>= 1.28-1),
 bzip2,
 xz-utils,
# Needed for git-style diff support.
 patch (>= 2.7),
 make,
 binutils,
 lto-disabled-list,
Recommends:
 build-essential,
 gcc | c-compiler,
 fakeroot,
 gnupg,
 gpgv,
# Used by dpkg-mergechangelogs.
 libalgorithm-merge-perl,
Suggests:
 debian-keyring,
Breaks:
# Force R³ support, w/o requiring debhelper users to depend on dpkg-dev.
 debhelper (<< 10.10.1~),
Description: Debian package development tools
 This package provides the development tools (including dpkg-source)
 required to unpack, build and upload Debian source packages.
 .
 Most Debian source packages will require additional tools to build;
 for example, most packages need make and the C compiler gcc.

Package: libdpkg-perl
Section: perl
Priority: optional
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${perl:Depends},
# Needed for arch tuples.
 dpkg (>= 1.18.11),
Recommends:
# Used by Dpkg::File.
 libfile-fcntllock-perl,
# Used by Dpkg::Gettext.
 liblocale-gettext-perl,
 bzip2,
 xz-utils,
Suggests:
 debian-keyring,
 gnupg,
 gpgv,
 gcc | c-compiler,
 binutils,
 patch,
# Used (if available) by Dpkg::Source::Package::V2.
 sensible-utils,
# Needed by Dpkg::Source::Package::V3::Git
 git,
# Needed by Dpkg::Source::Package::V3::Bzr
 bzr,
Breaks:
# Uses the private Dpkg::Shlibs::SymbolFile module with no API stability
# guarantees! Which obviously broke with 1.19.0.
 pkg-kde-tools (<< 0.15.28~),
# Uses Dpkg::Compression::Process imported from Dpkg::Source::Package in
# versions prior to 1.19.0.
 dgit (<< 3.13~),
Description: Dpkg perl modules
 This package provides the perl modules used by the scripts
 in dpkg-dev. They cover a wide range of functionality. Among them
 there are the following public modules:
 .
  - Dpkg: core variables
  - Dpkg::Arch: architecture handling functions
  - Dpkg::Build::Info: build information functions
  - Dpkg::BuildFlags: set, modify and query compilation build flags
  - Dpkg::BuildOptions: parse and manipulate DEB_BUILD_OPTIONS
  - Dpkg::BuildProfiles: parse and manipulate build profiles
  - Dpkg::Changelog: parse changelogs
  - Dpkg::Changelog::Entry: represents a changelog entry
  - Dpkg::Changelog::Parse: generic changelog parser for dpkg-parsechangelog
  - Dpkg::Checksums: generate and parse checksums
  - Dpkg::Compression: simple database of available compression methods
  - Dpkg::Compression::FileHandle: transparently (de)compress files
  - Dpkg::Compression::Process: wrapper around compression tools
  - Dpkg::Conf: parse dpkg configuration files
  - Dpkg::Control: parse and manipulate Debian control information
    (.dsc, .changes, Packages/Sources entries, etc.)
  - Dpkg::Control::Changelog: represent fields output by dpkg-parsechangelog
  - Dpkg::Control::Fields: manage (list of known) control fields
  - Dpkg::Control::Hash: parse and manipulate a block of RFC822-like fields
  - Dpkg::Control::Info: parse files like debian/control
  - Dpkg::Control::Tests: parse files like debian/tests/control
  - Dpkg::Control::Tests::Entry: represents a debian/tests/control stanza
  - Dpkg::Deps: parse and manipulate dependencies
  - Dpkg::Deps::Simple: represents a single dependency statement
  - Dpkg::Deps::Multiple: base module to represent multiple dependencies
  - Dpkg::Deps::Union: list of unrelated dependencies
  - Dpkg::Deps::AND: list of AND dependencies
  - Dpkg::Deps::OR: list of OR dependencies
  - Dpkg::Deps::KnownFacts: list of installed and virtual packages
  - Dpkg::Exit: push, pop and run exit handlers
  - Dpkg::Gettext: wrapper around Locale::gettext
  - Dpkg::IPC: spawn sub-processes and feed/retrieve data
  - Dpkg::Index: collections of Dpkg::Control (Packages/Sources files for
    example)
  - Dpkg::Interface::Storable: base object serializer
  - Dpkg::Path: common path handling functions
  - Dpkg::Source::Format: manipulate debian/source/format files
  - Dpkg::Source::Package: extract Debian source packages
  - Dpkg::Substvars: substitute variables in strings
  - Dpkg::Vendor: identify current distribution vendor
  - Dpkg::Version: parse and manipulate Debian package versions
 .
 All the packages listed in Suggests or Recommends are used by some of the
 modules.

Package: dselect
Priority: optional
Architecture: any
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Suggests:
 perl,
Description: Debian package management front-end
 dselect is a high-level interface for managing the installation and
 removal of Debian software packages.
 .
 Many users find dselect intimidating and new users may prefer to use
 apt-based user interfaces.

=== debian/rules ===
--- 
+++ 
@@ -128,7 +128,10 @@
 	dh_shlibdeps -a
 	dh_gencontrol -a
 	dh_md5sums -a
-	dh_builddeb -a
+	# Make debootstrap life easier on non-Debian based systems by
+	# compressing dpkg.deb with xz instead of zstd.
+	dh_builddeb -pdpkg -- -Zxz
+	dh_builddeb -a -Ndpkg
 
 # Put together the dpkg-dev package
 binary-indep: install

## dpkg 1.20.9ubuntu2.2

=== debian/changelog ===
dpkg (1.20.9ubuntu2.2) impish-security; urgency=medium

  * SECURITY UPDATE: Directory traversal issue in dpkg-source
    - scripts/Dpkg/Source/Archive.pm, scripts/t/Dpkg_Source_Archive.t:
      Prevent directory traversal for in-place extracts.
    - CVE-2022-1664

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 25 May 2022 07:13:51 -0400

dpkg (1.20.9ubuntu2.1) impish; urgency=medium

  * scripts/Dpkg/Vendor/Ubuntu.pm: When checking for the correct
    maintainer field, also look for canonical.com email addresses
    (LP: #1951988)

 -- William 'jawn-smith' Wilson <jawn-smith@ubuntu.com>  Thu, 02 Dec 2021 15:38:08 -0600

## dpkg 1.20.10

=== tests/t-conffile-declarative-removal/Makefile ===
TESTS_DEB := pkg-conffile-v1 pkg-conffile-v2

include ../Test.mk

test-case:
	# Conffile marked for removal but present, cannot be installed.
	$(DPKG_BUILD_DEB) --nocheck pkg-conffile-removal-present
	! $(DPKG_INSTALL) pkg-conffile-removal-present.deb
	$(call pkg_is_not_installed,pkg-conffile-removal-present)
	$(DPKG_PURGE) pkg-conffile-removal-present

	# Unmodified case.
	$(DPKG_INSTALL) pkg-conffile-v1.deb
	test -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed"
	$(DPKG_INSTALL) pkg-conffile-v2.deb
	test ! -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed"

	# Reset.
	$(DPKG_PURGE) pkg-conffile
	test ! -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed"

	# Unmodified case; but force it to happen via two invocations.
	$(DPKG_INSTALL) pkg-conffile-v1.deb
	test -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed"
	$(DPKG_UNPACK) pkg-conffile-v2.deb
	# The old file is still present when unpacked.
	test -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed"
	test ! -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed.dpkg-old"
	$(DPKG_CONFIGURE) pkg-conffile
	# After configure, the file is removed.
	test ! -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed"
	test ! -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed.dpkg-old"

	# Reset.
	$(DPKG_PURGE) pkg-conffile
	test ! -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed"

	# Modified; should store .dpkg-old.
	$(DPKG_INSTALL) pkg-conffile-v1.deb
	test -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed"
	echo "modify this" >"$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed"
	$(DPKG_INSTALL) pkg-conffile-v2.deb
	test ! -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed"
	test -f "$(DPKG_INSTDIR)/test-dir/test-conffile-to-be-removed.dpkg-old"

test-clean:
	$(DPKG_PURGE) pkg-conffile-removal-present
	$(DPKG_PURGE) pkg-conffile
	$(BEROOT) $(RM) -rf "$(DPKG_INSTDIR)/test-dir"

=== tests/t-unpack-symlink/Makefile ===
TESTS_DEB := pkg-symlink

include ../Test.mk

test-case:
	# test unpacking symlinks
	$(DPKG_INSTALL) pkg-symlink.deb
	$(call pkg_is_installed,pkg-symlink)

test-clean:
	$(DPKG_PURGE) pkg-symlink

=== debian/changelog ===
dpkg (1.20.10) bullseye-security; urgency=medium

  [ Guillem Jover ]
  * Perl modules:
    - Dpkg::Source::Archive: Prevent directory traversal for in-place extracts.
      Reported by Max Justicz <max@justi.cz>. Fixes CVE-2022-1664.
  * Localization:
    - Update Swedish translations.
      Thanks to Peter Krefting <peter@softwolves.pp.se>. Closes: #1007116

  [ Update man pages translations ]
  * German (Helge Kreutzmann).

 -- Guillem Jover <guillem@debian.org>  Tue, 24 May 2022 13:18:43 +0200

=== debian/rules ===
--- 
+++ 
@@ -65,7 +65,6 @@
 		--with-devlibdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) \
 		--without-libmd \
 		--with-libz \
-		--with-libzstd \
 		--with-liblzma \
 		--with-libbz2
 
@@ -128,10 +127,7 @@
 	dh_shlibdeps -a
 	dh_gencontrol -a
 	dh_md5sums -a
-	# Make debootstrap life easier on non-Debian based systems by
-	# compressing dpkg.deb with xz instead of zstd.
-	dh_builddeb -pdpkg -- -Zxz
-	dh_builddeb -a -Ndpkg
+	dh_builddeb -a
 
 # Put together the dpkg-dev package
 binary-indep: install

## dpkg 1.20.11

=== debian/changelog ===
dpkg (1.20.11) bullseye; urgency=medium

  [ Guillem Jover ]
  * dpkg-deb: Fix unexpected end of file conditions on .deb extract.
  * libdpkg: Do not restrict source:* virtual fields to installed packages.
    Closes: #1004372
  * Perl modules:
    - Dpkg::Source::Package::V2: Always fix the permissions for upstream
      tarballs. Closes: #1012195
  * Build system:
    - Build gitlab CI images for bullseye instead of sid.

 -- Guillem Jover <guillem@debian.org>  Sat, 02 Jul 2022 05:08:46 +0200

## dpkg 1.20.12

=== debian/changelog ===
dpkg (1.20.12) bullseye; urgency=medium

  [ Guillem Jover ]
  * dpkg: Fix conffile removal-on-upgrade handling. Closes: #995387
  * dpkg: Fix memory leak in remove-on-upgrade handling.
  * dpkg-fsys-usrunmess: Move forced reconfiguration to the last step.
    See #991190.
  * dpkg-fsys-usrunmess: Install a local policy-rc.d to ignore service
    restarts. Closes: #991190
  * dpkg-fsys-usrunmess: Do not fail when removing lingering directories.
  * dpkg-fsys-usrunmess: Fix typo in debug message.
  * dpkg-fsys-usrunmess: Explicitly set user/group and mode for created dirs.
    Closes: #1008478
  * dpkg-fsys-usrunmess: Set a known umask before starting.
    See #1008478.
  * dpkg-fsys-usrunmess: Special case untracked kernel module files.
    Closes: #1008316
  * dpkg-fsys-usrunmess: Handle /lib/modules itself also being untracked.
    Closes: #1008764
  * Architecture support:
    - Add support for ARCv2 CPU.
      Based on a patch by Alexey Brodkin <Alexey.Brodkin@synopsys.com>.
      Closes: #980963
  * Perl modules:
    - Dpkg::Shlibs::Objdump: Fix apply_relocations to work with versioned
      symbols. Closes: #1000421
  * Localization:
    - Fix missing newline in Dutch man pages translation.

 -- Guillem Jover <guillem@debian.org>  Thu, 01 Sep 2022 05:38:12 +0200
